
/* MiscTreeBrowserController.m
 *
 */

#import <stdio.h>
#import <stdlib.h>
#import <appkit/Font.h>
#import <misckit/_MiscTreeBrowserNode.h> 
#import <misckit/MiscTreeBrowser.h> 
#import <misckit/MiscTreeBrowserCell.h> 

#import "TestBed.h"

@implementation MiscTreeBrowserController

- init
{
	[super init];
	nodeC = 0;
	return self;
}

- free
{
	return [super free];
}

char *childString = "Child %d";
char *sibString = "Sibling %d";
char *nodeString = "Node %d";

/*(
Initialise MiscTreeBrowser.
)*/
- appDidInit:sender;
{
	id root = [[_MiscTreeBrowserNode alloc] initWithString:"Root" parent:nil];

//	printf("App did init.  TreeBrowser is 0x%8x.\n", (unsigned)treeBrowser);
	[treeBrowser setRoot:root];
	[treeBrowser setFont:[Font newFont:"Helvetica"
							   size:12
							   style:0
							   matrix:NX_FLIPPEDMATRIX]];
//	cellMatrix = [treeBrowser cellMatrix];
	[textf setStringValue:nodeString];
	return self;
}

/*(
Add a new node
)*/
- addChild:sender
{
	[treeBrowser addChild:[[_MiscTreeBrowserNode alloc] initWithString:[self getString:childString] parent:nil]];

	return self;
}

- addSibling:sender
{
	[treeBrowser addChild:[[_MiscTreeBrowserNode alloc] initWithString:[self getString:sibString] parent:nil]];
//	[treeBrowser addSibling:[[_MiscTreeBrowserNode alloc] init]];

	return self;
}

/*(
Delete all selected nodes.
)*/
- delete:sender
{
	[treeBrowser removeNode];

	return self;
}

- (char *)getString:(char *)defstr
{
	static char *theString = NULL;
	const char *guiString = [textf stringValue];

	if (!theString) theString = (char *)malloc(1024);
	nodeC++;
	sprintf(theString, (guiString ? guiString : defstr), nodeC);
	return theString;
}

@end
